#!/bin/sh
exec $ZEUSHOME/perl/miniperl -x $0 ${1+"$@"}
 if 0;
#!perl -w

BEGIN { @INC=( "$ENV{ZEUSHOME}/perl/", "$ENV{ZEUSHOME}/admin/etc" );
        unshift @INC, "$ENV{DOCROOT}/../lib" if defined $ENV{DOCROOT}; }

# Processes .zap style pages
#   <%...%>  are embedded perl statements
#   <%=...%> is shorthand for <% Z::write( $...) %>

unless ( defined( $ENV{PATH_TRANSLATED} )) { Error( "No PATH_TRANSLATED" ); }
unless ( -f $ENV{PATH_TRANSLATED} ) {
   Error ( "Cannot find file $ENV{PATH_TRANSLATED}" ); 
}


    
# Load in core routines that most pages will need
use Z;

# Grab the file
my $contents;
{
   local $/;
   open( FILE, "<$ENV{PATH_TRANSLATED}" ) or 
      Error ( "Cannot open file $ENV{PATH_TRANSLATED}" );
   $contents = scalar <FILE> || "";
   close FILE;
}

if( $ENV{PATH_TRANSLATED} =~ /^(.*)\// ){
   chdir( $1 );
}

# Parse the file, evaluating <% ... %>
$main::output = "";
%main::headers = ();  # Output headers
parse( $contents );   # fills $main::output

# Display the output
my $len = length $main::output;
# Insert our own headers
$main::headers{"Content-Type"}   = "text/html";
$main::headers{"Content-Length"} = $len;

my $hdrs = "";
while( my( $k,$v ) = each %main::headers ) {
    $hdrs .= "$k: $v\n";
}

print qq{$hdrs

$main::output};
exit 0;

BEGIN {
   my $terminate = 0;  # terminate early flag
   my $recursion = 0;  # our level of recursion
   
   sub parse {
      my( $contents ) = @_;
      
      if( $recursion > 20 ) {
         $main::output .= "<xmp>Recursion level exceeded</xmp>";
         return;
      }
      
      while( $contents =~ /<%(.*?)%>/ms ) {
         $main::output .= $`;
         my $command = $1;
         $contents = $';
         
         if( $command =~ /^=/ ) {
            # Its a <%= ... %> type command, rewrite
            $command =~ s/^=\s*//;       # remove leading = & whitespace
            $command =~ s/\s*^//;        # remove trailing whitespace
            $command = sprintf "Z::write(%s)", $command;
         }
         $recursion++;
         eval $command;
         $recursion--;
         if( $@ ) {
            # exception thrown
            if( ! ($@ =~ /stop parse/) ) {
               # bad stop, display error
               Error( "$@\n\nCode was:\n$command" );
            }
            $terminate = 1;
            last;
         }
      }
      $main::output .= $contents unless( $terminate );
   }
}


# ----------------------------------------------------------
# Display an error message

sub Error {
    print qq{Content-Type: text/html

<body bgcolor=white>
<font color=#990000><b>Error:</b></font> $_[0]
</body>
};
    exit 1;
}


