#ifndef __WINTYPES_H
#define __WINTYPES_H

/*!
 * \file
 * \brief Windows data types

   This file is basically for additions and alterations to the
   standard ISAPI header files.  A lot of the stuff is for defining
   Windows types on Unix. */

#ifndef WIN32
/* define windows types on Unix  */
typedef int   BOOL;
typedef char* LPSTR;
typedef const char * LPCSTR;
typedef void* LPVOID;
typedef void* PVOID;
typedef void  VOID;
typedef int*  LPDWORD;
typedef int   DWORD;
typedef char  CHAR;
typedef unsigned char* LPBYTE;
typedef short WORD;
typedef char  BYTE;
typedef long  LONG;
typedef void* HANDLE;

#define TRUE  1
#define FALSE 0

#define WINAPI

int GetLastError();
int SetLastError();

#define NO_ERROR 0
#define ERROR_INVALID_PARAMETER 1
#define ERROR_INVALID_INDEX    2
#define ERROR_INSUFFICIENT_BUFFER 3
#define ERROR_MORE_DATA 4
#define ERROR_NO_DATA   5 

#define MAKEWORD(a, b) ((WORD) (((BYTE) (a)) | ((WORD) ((BYTE) (b))) << 8))

#define MAKELONG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16)) 

#else
#include <wtypes.h>
#endif /* !WIN32 */


typedef void* HCONN;

#ifndef HINSTANCE
#define HINSTANCE void*
#endif

typedef BOOL WINAPI (*DllMainf)
   ( HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved );

#define DLL_PROCESS_ATTACH 0
#define DLL_THREAD_ATTACH  1
#define DLL_THREAD_DETACH  2
#define DLL_PROCESS_DETACH 3




#endif









