#!/bin/sh
exec $ZEUSHOME/perl/miniperl -x $0 ${1+"$@"}
 if 0;
#!perl -w

BEGIN { @INC=( "$ENV{ZEUSHOME}/perl/", "$ENV{ZEUSHOME}/webadmin/etc/" ); }
use ZeusOS;
use WebAdmin;

# Renders a HTML page of the current status of a particular worker
# worker in query_string
# TODO: when we get ahtml pages sorted, replace this CGI!

$lb = $ENV{QUERY_STRING} or Error( "No QUERY_STRING!" );
( $lb ) = $lb =~ /machine=(.*)/;


# Check the given worker exists in the lbs file
$lbfile = "$ENV{ZEUSHOME}/webadmin/conf/lbs";
$found  = 0;
open( FILE, $lbfile ) or Error( "Can't open $lbfile : $!" );
while( <FILE> ) {
    chomp;
    if( $_ eq $lb ) { $found = 1; last; }
}
close( FILE );
Error( "$lb is not a registered load-balancer" ) unless( $found );

# Now contact the load-balancer, and ask it what its upto
($host,$port) = split /:/, $lb;
$response = WebAdmin::command( $host, $port, "cells\n", $err );
$response ||= "Failure\n$err";
($status,$data) = split /\n/, $response, 2;
Error( $data ) unless ( $status eq "Success" );

# See how many backend servers we've got in the response - how we format the
# table depends upon the number of servers
@data = sort SortByResponse split( /\n/, $data );
$backends = @data;

if( $backends < 5 ) {
  # Use huge, space-wasting layout and big icons
  $layout = "<tr><td align=middle valign=top><img src=single-%s hspace=20 "
          . "vspace=10><br><font size=-1>%s</font></td><td valign=middle>"
          . "<img src=reddot.gif height=5 width=%d>&nbsp;<font size=-1>"
          . "(%d%%)<p>Response time = %.1f ms</p></font></td></tr>\n";
} elsif( $backends < 9 ) {
  # Small icons, bit more compactly organised
  $layout = "<tr><td align=right valign=middle><img src=single-mini-%s "
          . "hspace=5 vspace=5 align=right><font size=-1><br><br>%s</font>"
          . "</td><td valign=middle>"
          . "<img src=reddot.gif height=5 width=%d>&nbsp;<font size=-1>"
          . "(%d%%)<p>Response time = %.1f ms</p></font></td></tr>\n";
} else {
  # Tiny icons, really compact
  $layout = "<tr><td align=right valign=center><img src=tiny-%s align=right>"
          . "<font size=-1>%s"
          . "</font></td><td valign=middle>"
          . "<img src=reddot.gif height=5 width=%d>&nbsp;<font size=-1>"
          . "(%d%%)</font></td><td>"
          . "<font size=-1>Response time = %.1f ms</font></td></tr>\n";
}

# Now generate our data
$o = "<table border=0 width=\"80%\"><tr><td align=middle><b>Machine</b></td>" .
      "<td><b>Percentage Load</b></td></tr>";

foreach $_ ( @data ) {
    ( $name, $percent, $load, $_ ) = split /:/;
    $o .= sprintf( qq{ $layout }, ( $percent == 0 || $load > 500000 )
                   ? "deadserver.gif" : "server.gif", $name, 
                   $percent*3, $percent, $load / 1000 );
}
$o .= "</table>";

Display( $o );
exit 0;

# ----------------------------------------------------------

# Sort backend servers by their response times, so larger response times
# are printed at the top
sub SortByResponse
{
    ( $_, $_, $load1, $_ ) = split( /:/, $a );
    ( $_, $_, $load2, $_ ) = split( /:/, $b );
    $load2 <=> $load1;
}      
  

sub Error
{
    my( $msg ) = @_;
    Display( "<h2>Error</h2><ul><pre>$msg</pre></ul>" );
}

sub Display
{
    my( $msg ) = @_;
    print qq{Content-Type: text/html

<html>
<head>
<title>Traffic distribution - $host</title>
</head>

<body bgcolor="#ffffff" link=#990066 vlink=#990066 alink=#990066>

<table>
<tr>
 <td valign=top>
  <img src="/apps/web/title.gif" hspace=10 alt="">
  <p align=right>

  <a href="/apps/admin/docsystem/context.ahtml?help=/apps/web/docs/controller/loadbalancers.html" target="help" onClick=
     "window.open('','help','resizable=1,width=640,height=500'); return true;">
        <img src="/apps/web/docs.gif" 
        alt="[documentation]" align=bottom border=0 hspace=0></a>

  <a href="/apps/web/cluster/status.ahtml"><img src="/apps/web/back.gif" 
        alt="[back]" align=bottom border=0 hspace=0></a>
        <a href="/apps/web/"><img src="/apps/web/home.gif" alt="[Controller]" 
        align=bottom border=0></a>
  </td>
  <td valign=top>


<br>

<center>
<table width=100% cellpadding=4 cellspacing=0 border=0>
<tr>
 <td>
    <img src="title-clusterstatus.gif" alt="Cluster Status">
 </td>
</tr>
<tr valign=center bgcolor=#cfcfcf >
 <td>
 <font size=+2 color=#000000>Traffic Distribution ($host)</font>
 </td>
</tr>
</table>
</center>
<p>

This page shows the real-time traffic distribution between the
frontend load-balancer node $host and the backend webservers. <p>

$msg

</td>
</tr>
</table>

</body>
</html>
};
    exit;
}
